#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

struct segment {
    ll l;
    ll r;
    ll w;
};

segment merge_segments(vector<ll> &H, segment a, segment b) {
    if (a.l == -1)
        return b;
    if (b.l == -1)
        return a;

    segment res = {a.l, b.r, 0};

    int j = a.l;
    ll sum = H[a.l];
    for (int i = a.l + 1; i <= b.r; i++) {
        sum += H[i];

        if (H[j] <= H[i]) {
            res.w += min(H[i], H[j]) * (i - j - 1) - (sum - (H[i] + H[j]));

            sum = H[i];
            j = i;
        }
    }

    j = b.r, sum = H[b.r];
    for (int i = b.r - 1; i >= a.l; i--) {
        sum += H[i];

        if (H[j] <= H[i]) {
            res.w += min(H[i], H[j]) * (j - i - 1) - (sum - (H[i] + H[j]));

            sum = H[i];
            j = i;
        }
    }

    return res;
}

void build_tree(vector<segment> &T, vector<ll> &H, int v, int l, int r) {
    if (r - l == 1) {
        T[v] = {l, r - 1, 0};
        return;
    }

    int mid = (l + r) / 2;
    build_tree(T, H, 2 * v + 1, l, mid);
    build_tree(T, H, 2 * v + 2, mid, r);

    T[v] = merge_segments(H, T[2 * v + 1], T[2 * v + 2]);
}

segment get_segment(vector<segment> &T, vector<ll> &H, int v, int l, int r, int lq, int rq) {
    if (lq <= l && r <= rq) {
        return T[v];
    }

    if (r <= lq || l >= rq) {
        return {-1, -1, 0};
    }

    int mid = (l + r) / 2;
    segment s1 = get_segment(T, H, 2 * v + 1, l, mid, lq, rq);
    segment s2 = get_segment(T, H, 2 * v + 2, mid, r, lq, rq);

    return merge_segments(H, s1, s2);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n;
    cin >> n;

    vector<ll> H(n);
    set<pair<int, int>> B;

    for (int i = 0; i < n; i++) {
        cin >> H[i];
        B.insert({i, i});
    }

    vector<segment> T(4 * n);
    build_tree(T, H, 0, 0, n);

    for (int i = 0; i < n - 1; i++) {
        int k;
        cin >> k;

        k--;

        set<pair<int, int>>::iterator it1 = next(B.begin(), k);
        set<pair<int, int>>::iterator it2 = next(B.begin(), k + 1);

        cout << get_segment(T, H, 0, 0, n, (*it1).first, (*it2).second + 1).w << endl;

        B.insert({(*it1).first, (*it2).second});
        B.erase(it1);
        B.erase(it2);
    }
    return 0;
}
