#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 1e9 + 1;

struct segment {
    ll sum;
    ll min_num;
    ll max_num;
};

segment merge_segments(segment a, segment b) {
    return {a.sum + b.sum, min(a.min_num, b.min_num), max(a.max_num, b.max_num)};
}

void build_tree(vector<segment> &T, vector<ll> &A, ll v, ll l, ll r) {
    if (r - l == 1) {
        T[v] = {A[l], A[l], A[l]};
        return;
    }

    ll mid = (l + r) / 2;
    build_tree(T, A, 2 * v + 1, l, mid);
    build_tree(T, A, 2 * v + 2, mid, r);

    T[v] = merge_segments(T[2 * v + 1], T[2 * v + 2]);
}

segment get_segment(vector<segment> &T, ll v, ll l, ll r, ll lq, ll rq) {
    if (l >= lq && r <= rq)
        return T[v];

    if (l >= rq || r <= lq)
        return {0, INF, -INF};

    ll mid = (l + r) / 2;
    segment s1 = get_segment(T, 2 * v + 1, l, mid, lq, rq);
    segment s2 = get_segment(T, 2 * v + 2, mid, r, lq, rq);

    return merge_segments(s1, s2);
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    ll n, k;
    cin >> n >> k;

    ll m = n - (k - 1);

    vector<ll> A(n);
    for (ll i = 0; i < n; i++) {
        cin >> A[i];
    }

    vector<segment> T(4 * n, {0, INF, -INF});
    build_tree(T, A, 0, 0, n);

    ll ans = -INF;
    for (ll i = 0; i < n - m + 1; i++) {
        segment s1 = get_segment(T, 0, 0, n, 0, i);
        segment s2 = get_segment(T, 0, 0, n, i, i + m);
        segment s3 = get_segment(T, 0, 0, n, i + m, n);

        ll max_sum = max(s2.sum, max(s1.max_num, s3.max_num));
        ll min_sum = min(s2.sum, min(s1.min_num, s3.min_num));

        ans = max(ans, max_sum - min_sum);
    }

    cout << ans;
    return 0;
}
